package com.nisum.psspringboot1.controllers;

import com.nisum.psspringboot1.models.Session;
import com.nisum.psspringboot1.repositories.SessionRepository;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/api/v1/sessions")
public class SessionController {
    @Autowired
    SessionRepository repository;

    @GetMapping
    public List<Session> getAllSessions() { return repository.findAll(); }

    @GetMapping("{id}")
    public Session getSessionById(@PathVariable("id") long id) { return repository.getOne(id); }

    @PostMapping
    public Session postSession(@RequestBody final Session session) { return repository.saveAndFlush(session); }

    @PutMapping("{id}")
    public Session updateSession(@PathVariable("id") Long id, @RequestBody Session session) {
        Session staleSession = repository.getOne(id);
        BeanUtils.copyProperties(session, staleSession, "session_id");
        return repository.saveAndFlush(staleSession);
    }

    @DeleteMapping("{id}")
    public void deleteSession(@PathVariable("id") Long id) { repository.deleteById(id); }
}
