package com.nisum.psspringboot1.models;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import org.hibernate.annotations.Type;

import javax.persistence.*;
import java.util.List;

@Entity(name = "speakers")
@JsonIgnoreProperties({"hibernateLazyInitializer", "handler"})
public class Speaker {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long speaker_id;
    private String first_name;
    private String last_name;
    private String title;
    private String company;
    private String speaker_bio;

    @Lob
    @Type(type = "org.hibernate.type.BinaryType")
    private byte[] speaker_photo;

    @ManyToMany(mappedBy = "speakers")
    @JsonIgnore
    private List<Session> sessions;

    public List<Session> getSessions() {
        return sessions;
    }

    public Speaker setSessions(List<Session> sessions) {
        this.sessions = sessions;
        return this;
    }

    public Speaker() {}

    public Long getSpeaker_id() {
        return speaker_id;
    }

    public Speaker setSpeaker_id(Long speaker_id) {
        this.speaker_id = speaker_id;
        return this;
    }

    public String getFirst_name() {
        return first_name;
    }

    public Speaker setFirst_name(String first_name) {
        this.first_name = first_name;
        return this;
    }

    public String getLast_name() {
        return last_name;
    }

    public Speaker setLast_name(String last_name) {
        this.last_name = last_name;
        return this;
    }

    public String getTitle() {
        return title;
    }

    public Speaker setTitle(String title) {
        this.title = title;
        return this;
    }

    public String getCompany() {
        return company;
    }

    public Speaker setCompany(String company) {
        this.company = company;
        return this;
    }

    public String getSpeaker_bio() {
        return speaker_bio;
    }

    public Speaker setSpeaker_bio(String speaker_bio) {
        this.speaker_bio = speaker_bio;
        return this;
    }
}
